/* main.h - NeonServ v5.6
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */
#ifndef _main_h
#define _main_h
#include "overall.h"

struct ProcessState {
    time_t start_time;
    int running : 1;
    int restart : 1;
    int run_as_daemon : 1;
    int daemonized : 1;
    int loglevel : 8;
    int loaded_config : 1;
    int running_threads : 8;
    
    int argc;
    char **argv;
    
    char config[MAXLEN];
    char pidfile[MAXLEN];
};

#ifndef DND_FUNCTIONS

extern struct ProcessState process_state;

#ifdef HAVE_THREADS
extern pthread_mutex_t cache_sync;
extern pthread_mutex_t whohandler_sync, whohandler_mass_sync;

/* MODULAR ACCESSIBLE */ int getCurrentThreadID();
#endif

/* MODULAR ACCESSIBLE */ time_t getStartTime();
/* MODULAR ACCESSIBLE */ int getRunningThreads();

/* MODULAR ACCESSIBLE */ void restart_bot(int crash);
/* MODULAR ACCESSIBLE */ void stop_bot();
/* MODULAR ACCESSIBLE */ void reload_config();
#endif
#endif