/* cmd_neonserv_csuspend.c - NeonServ v5.6
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_neonserv.h"

/*
* argv[0] - channel
*/
CMD_BIND(neonserv_cmd_csuspend) {
    MYSQL_RES *res;
    MYSQL_ROW row;
    char *channel = argv[0];
    if(!is_valid_chan(channel)) {
        reply(textclient, user, "NS_INVALID_CHANNEL_NAME", argv[0]);
        return;
    }
    int chanid;
    printf_mysql_query("SELECT `channel_id` FROM `channels` WHERE `channel_name` = '%s'", escape_string(channel));
    res = mysql_use();
    if ((row = mysql_fetch_row(res)) != NULL) {
        chanid = atoi(row[0]);
    } else {
        reply(textclient, user, "NS_UNREGISTER_NOT_REGISTERED", argv[0], client->user->nick);
        return;
    }
    printf_mysql_query("SELECT `botid`, `bot_channels`.`id`, `suspended` FROM `bot_channels` LEFT JOIN `bots` ON `bot_channels`.`botid` = `bots`.`id` WHERE `chanid` = '%d' AND `botclass` = '%d'", chanid, client->botid);
    res = mysql_use();
    if ((row = mysql_fetch_row(res)) == NULL) {
        reply(textclient, user, "NS_UNREGISTER_NOT_REGISTERED", argv[0], client->user->nick);
        return;
    }
    if(!strcmp(row[2], "1")) {
        reply(textclient, user, "NS_CSUSPEND_ALREADY", channel);
        return;
    }
    int botid = atoi(row[0]);
    struct ClientSocket *bot;
    for(bot = getBots(SOCKET_FLAG_READY, NULL); bot; bot = getBots(SOCKET_FLAG_READY, bot)) {
        if(bot->clientid == botid)
            break;
    }
    if(bot) {
        putsock(bot, "PART %s :Channel suspended.", channel);
    }
    if(client->botid == NEONSERV_BOTID) {
        char setting[128];
        sprintf(setting, "modules.%s.auto_backup_unregister", get_module_name(module_id));
        if(get_int_field(setting))
            module_global_cmd_unregister_neonbackup(channel);
    }
    printf_mysql_query("UPDATE `bot_channels` SET `suspended` = '1' WHERE `id` = '%s'", row[1]);
    reply(textclient, user, "NS_CSUSPEND_DONE", channel);
    logEvent(event);
}
