/* cmd_global_bind.c - NeonServ v5.6
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_global.h"

/*
* argv[0]   command name
* argv[1]   command function
* argv[2-*] parameters (optional)
*/

CMD_BIND(global_cmd_bind) {
    MYSQL_RES *res;
    MYSQL_ROW row;
    if(client->botid == 0)
        printf_mysql_query("SELECT `function` FROM `bot_binds` WHERE `botclass` = '%d' AND `botid` = '%d' AND `command` = '%s'", client->botid, client->clientid, escape_string(argv[0]));
    else
        printf_mysql_query("SELECT `function` FROM `bot_binds` WHERE `botclass` = '%d' AND `command` = '%s'", client->botid, escape_string(argv[0]));
    res = mysql_use();
    if ((row = mysql_fetch_row(res)) != NULL) {
        reply(textclient, user, "NS_BIND_ALREADY", argv[0], row[0]);
        return;
    }
    char *params;
    if(argc > 2)
        params = merge_argv(argv, 2, argc);
    else
        params = "";
    struct cmd_function *function = find_cmd_function(client->botid, argv[1]);
    if(!function) {
        reply(textclient, user, "NS_BIND_UNKNOWN", argv[1]);
        return;
    }
    bind_botwise_cmd_to_function(client->botid, client->clientid, argv[0], function);
    printf_mysql_query("INSERT INTO `bot_binds` (`botclass`, `botid`, `command`, `function`, `parameters`) VALUES ('%d', '%d', '%s', '%s', '%s')", client->botid, (client->botid == 0 ? client->clientid : 0), escape_string(argv[0]), escape_string(argv[1]), params);
    if(*params)
        bind_botwise_set_parameters(client->botid, client->clientid, argv[0], params);
    reply(textclient, user, "NS_BIND_DONE", argv[0], function->name);
    logEvent(event);
}
